/*
 * Some of the X headers are not very friendly in terms of namespace.
 * For example, X.h typedef's Mask but we use Mask in the core of pcb
 * and this causes problem.  To avoid this, pull in the X headers in
 * this file where we can add workarounds as needed.
 */

#define Mask X_Mask

#include <X11/Intrinsic.h>
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/cursorfont.h>
#include <X11/keysym.h>

#include <Xm/CascadeB.h>
#include <Xm/DrawingA.h>
#include <Xm/FileSB.h>
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/List.h>
#include <Xm/MainW.h>
#include <Xm/MenuShell.h>
#include <Xm/MessageB.h>
#include <Xm/Protocols.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>
#include <Xm/Scale.h>
#include <Xm/ScrollBar.h>
#include <Xm/ScrolledW.h>
#include <Xm/Separator.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <Xm/ToggleB.h>
#include <Xm/Xm.h>

#ifdef RND_HAVE_XRENDER
#include <X11/extensions/Xrender.h>
#endif /* RND_HAVE_XRENDER */

#ifdef RND_HAVE_XINERAMA
#include <X11/extensions/Xinerama.h>
#endif /* RND_HAVE_XINERAMA */

#undef Mask
